//////////////////////////////////////////////////////////////////////////
//	"devarglist.cpp"
//------------------------------------------------------------------------
//	$Id: devarglist.cpp 57 2003-12-11 15:32:55Z  $
//////////////////////////////////////////////////////////////////////////

#include	"devtest.h"

#if	defined(DEVTEST_USE_STL_LIST)
// No Build
#else
DevTest::DevArgList::DevArgList()
{
	this->numItem    = 0;
	this->itop.item  = NULL;
	this->ilast.item = NULL;
	this->icur.item  = NULL;
	this->iend.item  = NULL;
}

DevTest::DevArgList::~DevArgList()
{
	this->clear();
}

void		DevTest::DevArgList::clear(void)
{
	Item		*x, *x_next;

	x = this->itop.item;
	while ( x != NULL )
	{
		x_next = x->next;
		delete x;
		x = x_next;
	}
	this->numItem = 0;
	this->itop.item = this->ilast.item = NULL;
	this->icur.item = NULL;
}

DevTest::DevArgList::iterator 	DevTest::DevArgList::insert(DevTest::DevArgList::iterator & base, const DevTest::DevParam * s)
{
	Item *		x;
	iterator	it;

	if ( (x = new Item) == NULL )
	{
		it.item = NULL;
		return it;
	}
	x->p = (DevTest::DevParam *)s;
	if ( base.item == NULL )
	{
#if 1
		// Add last
		x->next = NULL;
		x->prev = this->ilast.item;
		if ( x->prev != NULL )
			x->prev->next = x;
		else
			this->itop.item = x;
		this->ilast.item = x;
#else
		// Insert top
		x->next = this->itop.item;
		if ( x->next != NULL )
			x->next->prev = x;
		else
			this->ilast.item = x;
		x->prev = NULL;
		this->itop.item = x;
#endif
	} else
	{
		x->next = base.item;
		if ( x->next != NULL )
			x->next->prev = x;
		else
			this->ilast.item = x;
		x->prev = base.item->prev;
		if ( x->prev != NULL )
			x->prev->next = x;
		else
			this->itop.item = x;
	}
	this->numItem++;
	this->icur.item = x;
	it.item = x;
	return it;
}

void	DevTest::DevArgList::remove(DevTest::DevArgList::iterator & it)
{
	Item *	x = it.item;

	if ( x == NULL )
		return;
	if ( x->next != NULL )
		x->next->prev = x->prev;
	else
		this->ilast.item = x->prev;
	if ( x->prev != NULL )
		x->prev->next = x->next;
	else
		this->itop.item = x->next;
	this->numItem--;
	this->icur.item = NULL;
}
#endif
